### Hierarchy

- ISimpleBracket
  - SimpleEllipsisBracket

### Implements

- ICacheable

## Index

### Constructors

- constructor

### Properties

- __coverageCount
- __source
- afterEllipsisBracket
- beforeEllipsisBracket
- debugFlag
- direction
- firstCells

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- __incrementCoverage
- _getAllNeighbors
- addCell
- addCellsToEmptyRules
- addFirstCell
- clearCaches
- getMatches
- hasMatches
- prepareAction
- removeCell
- removeFirstCell
- subscribeToNeighborChanges
- toKey
- toSourceString
- toString

## Constructors

### constructor

- new SimpleEllipsisBracket(source: IGameCode, direction: RULE_DIRECTION, beforeEllipsisNeighbors: SimpleNeighbor[], afterEllipsisNeighbors: SimpleNeighbor[], debugFlag: Optional<DEBUG_FLAG>): SimpleEllipsisBracket

- Overrides ISimpleBracket.constructor

  - Defined in models/rule.ts:1136

  #### Parameters

  - ##### source: IGameCode

  - ##### direction: RULE_DIRECTION

  - ##### beforeEllipsisNeighbors: SimpleNeighbor[]

  - ##### afterEllipsisNeighbors: SimpleNeighbor[]

  - ##### debugFlag: Optional<DEBUG_FLAG>

  #### Returns SimpleEllipsisBracket

## Properties

### __coverageCount

__coverageCount: Optional<number>

Inherited from BaseForLines.__coverageCount

- Defined in models/BaseForLines.ts:69

### __source

__source: IGameCode

Inherited from BaseForLines.__source

- Defined in models/BaseForLines.ts:68

### afterEllipsisBracket

afterEllipsisBracket: SimpleBracket

- Defined in models/rule.ts:1135

### beforeEllipsisBracket

beforeEllipsisBracket: SimpleBracket

- Defined in models/rule.ts:1134

### debugFlag

debugFlag: Optional<DEBUG_FLAG>

Inherited from ISimpleBracket.debugFlag

- Defined in models/rule.ts:625

### direction

direction: RULE_DIRECTION

Inherited from ISimpleBracket.direction

- Defined in models/rule.ts:626

### Protected firstCells

firstCells: Set<Cell>

Inherited from ISimpleBracket.firstCells

- Defined in models/rule.ts:627

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Inherited from BaseForLines.__getLineAndColumnRange

  - Defined in models/BaseForLines.ts:96

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Inherited from BaseForLines.__getSourceLineAndColumn

  - Defined in models/BaseForLines.ts:81

  #### Returns object

  - ##### colNum: number

  - ##### line: string

  - ##### lineNum: number

  - ##### nextLine: null | string

  - ##### prevLine: null | string

### __incrementCoverage

- __incrementCoverage(): void

- Inherited from BaseForLines.__incrementCoverage

  - Defined in models/BaseForLines.ts:104

  #### Returns void

### _getAllNeighbors

- _getAllNeighbors(): SimpleNeighbor[]

- Inherited from ISimpleBracket._getAllNeighbors

  - Defined in models/rule.ts:646

  #### Returns SimpleNeighbor[]

### addCell

- addCell(index: number, neighbor: SimpleNeighbor, t: SimpleTileWithModifier, sprite: GameSprite, cell: Cell, wantsToMove: Optional<RULE_DIRECTION>): void

- Overrides ISimpleBracket.addCell

  - Defined in models/rule.ts:1169

  #### Parameters

  - ##### index: number

  - ##### neighbor: SimpleNeighbor

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cell: Cell

  - ##### wantsToMove: Optional<RULE_DIRECTION>

  #### Returns void

### addCellsToEmptyRules

- addCellsToEmptyRules(cells: Iterable<Cell>): void

- Overrides ISimpleBracket.addCellsToEmptyRules

  - Defined in models/rule.ts:1164

  #### Parameters

  - ##### cells: Iterable<Cell>

  #### Returns void

### addFirstCell

- addFirstCell(bracket: SimpleBracket, firstCell: Cell, token: BEFORE_OR_AFTER): void

- - Defined in models/rule.ts:1176

  #### Parameters

  - ##### bracket: SimpleBracket

  - ##### firstCell: Cell

  - ##### token: BEFORE_OR_AFTER

  #### Returns void

### clearCaches

- clearCaches(): void

- Overrides ISimpleBracket.clearCaches

  - Defined in models/rule.ts:1153

  #### Returns void

### getMatches

- getMatches(level: Level, actionBracket: Optional<SimpleEllipsisBracket>): MatchedCellsForRule[]

- Overrides ISimpleBracket.getMatches

  - Defined in models/rule.ts:1259

  #### Parameters

  - ##### level: Level

  - ##### actionBracket: Optional<SimpleEllipsisBracket>

  #### Returns MatchedCellsForRule[]

### hasMatches

- hasMatches(level: Level, actionBracket: Optional<ISimpleBracket>): boolean

- Inherited from ISimpleBracket.hasMatches

  - Defined in models/rule.ts:649

  #### Parameters

  - ##### level: Level

  - ##### actionBracket: Optional<ISimpleBracket>

  #### Returns boolean

### prepareAction

- prepareAction(action: ISimpleBracket): void

- Overrides ISimpleBracket.prepareAction

  - Defined in models/rule.ts:1159

  #### Parameters

  - ##### action: ISimpleBracket

  #### Returns void

### removeCell

- removeCell(index: number, neighbor: SimpleNeighbor, t: SimpleTileWithModifier, sprite: GameSprite, cell: Cell): void

- Overrides ISimpleBracket.removeCell

  - Defined in models/rule.ts:1172

  #### Parameters

  - ##### index: number

  - ##### neighbor: SimpleNeighbor

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cell: Cell

  #### Returns void

### removeFirstCell

- removeFirstCell(bracket: SimpleBracket, firstCell: Cell, token: BEFORE_OR_AFTER): void

- - Defined in models/rule.ts:1209

  #### Parameters

  - ##### bracket: SimpleBracket

  - ##### firstCell: Cell

  - ##### token: BEFORE_OR_AFTER

  #### Returns void

### subscribeToNeighborChanges

- subscribeToNeighborChanges(): void

- Overrides ISimpleBracket.subscribeToNeighborChanges

  - Defined in models/rule.ts:1143

  #### Returns void

### toKey

- toKey(): string

- Overrides ISimpleBracket.toKey

  - Defined in models/rule.ts:1149

  #### Returns string

### toSourceString

- toSourceString(): string

- Inherited from BaseForLines.toSourceString

  - Defined in models/BaseForLines.ts:90

  #### Returns string

### toString

- toString(): string

- Inherited from BaseForLines.toString

  - Defined in models/BaseForLines.ts:85

  #### Returns string

Generated using TypeDoc